# coding: utf-8

"""
    JupyterHub

    The REST API for JupyterHub

    The version of the OpenAPI document: 4.0.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import BaseModel, StrictBool, StrictFloat, StrictInt, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class Service(BaseModel):
    """
    Service
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="The service's name")
    admin: Optional[StrictBool] = Field(default=None, description="Whether the service is an admin")
    roles: Optional[List[StrictStr]] = Field(default=None, description="The names of roles this service has")
    url: Optional[StrictStr] = Field(default=None, description="The internal url where the service is running")
    prefix: Optional[StrictStr] = Field(default=None, description="The proxied URL prefix to the service's url")
    pid: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The PID of the service process (if managed)")
    command: Optional[List[StrictStr]] = Field(default=None, description="The command used to start the service (if managed)")
    info: Optional[Dict[str, Any]] = Field(default=None, description="Additional information a deployment can attach to a service. JupyterHub does not use this field. ")
    __properties: ClassVar[List[str]] = ["name", "admin", "roles", "url", "prefix", "pid", "command", "info"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of Service from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of Service from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "admin": obj.get("admin"),
            "roles": obj.get("roles"),
            "url": obj.get("url"),
            "prefix": obj.get("prefix"),
            "pid": obj.get("pid"),
            "command": obj.get("command"),
            "info": obj.get("info")
        })
        return _obj


